#ifndef __PERMFILE_H__
#define __PERMFILE_H__

#include <glib.h>

#include "commondef.h"

struct perm_s
{ 
  gint32 uid;
  gint32 gid;
  gint32 perm;
  gint32 dlc;
  gint32 dlct;
  gchar reserved[28];
};

struct file_s
{ 
  gchar name[MAXFILENAMELENGTH];
  gint32 uid;
  gint32 gid;
  gint32 dlc;
  gint32 perm;
};

/* old permission file */
typedef struct
{
  struct perm_s dir;
  struct file_s files[0];
} permfile_t;

/* old */

/* common */

struct file_s *find_name (struct file_s *buffer, gchar *name, gint n, gint *found);

gint32 dirperm_to_fileperm (gint32 perm);

/* ftpd */

gint read_permfile (gchar *filename, gchar **buffer, gint *n, guint32 umask_root);

gint write_permfile (gchar *filename, gchar **buffer, gint n);

/* ftps */

gint read_permission_file (const gchar *dir, gint32 *uid, gint32 *gid, 
			   gint32 *perm, gint32 *dlc, gchar **buffer, gint *n);

gint remove_permission_file (gchar *dir);

gint write_permission_file (gchar *dir, gint32 uid, gint32 gid, gint32 perm);


gint read_file_permission (const gchar *dir, gchar *name, gint32 *uid, 
			   gint32 *gid, gint32 *perm);

#endif /* __PERMFILE_H__ */
