/* ---------------------------------------------------------------------------
 *
 *   This file is part of OpenFTPD (based on FTP4ALL)
 *   (C) 1996-2000 by Crescent, (C) 2000 by the OpenFTPD Team
 *
 * ---------------------------------------------------------------------------
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 * ---------------------------------------------------------------------------
 *   HEADER: globalsd.h - global variables
 * ---------------------------------------------------------------------------
 */

#include "definesd.h"

char default_base_dir[]        = "/home/ftp";
char default_permission_file[] = ".permissions";

char default_who_top_msg[] = 
   " !C.------------------------------------------------------------------------.!0\n"
   " !C|!3!B OpenFTPD !HONLINE USERS                                                  !0!C|!0\n"
   " !C|------------------------------------------------------------------------|!0\n";

char default_who_body_msg[] = 
   " !C|!c[!H%W[%02li]C!c] !c[!CUSER: !H%W[%-9.9s]N!c] [!CGROUP: !H%W[%-9.9s]G!c]"
   " [!CON-TM: !H%W[%H:%M]T!c] [!CAC-TM: !H%W[%H:%M]t!c] !C|!0\n"
   " !C|     !c[!CACTIVITY: !H%W[%-54.54s]A!c] !C|!0\n"
   " !C|     !c[!CPATH: !H%W[%-37.37s]P!c] [!CSPEED: !H%W[%6.1f]s !hKB/s!c] !C|!0\n"
   " !C|------------------------------------------------------------------------|!0\n";

char default_who_tail_msg[] = 
   " !C|!c[!CTRAFFIC: !H%W[%7.1f]U !hKB/s (UL)   !H%W[%7.1f]D !hKB/s (DL)   "
   "!H%W[%7.1f]S !hKB/s (TOTAL)!c] !C|!0\n"
   " !C`------------------------------------------------------------------------+!0\n";

char default_swho_top_msg[] = 
   " !C.------------------------------------------------------------------------.!0\n"
   " !C|!3!B OpenFTPD !HONLINE USERS (OPERATOR VIEW)                             "
   "     !0!C|!0\n"
   " !C|------------------------------------------------------------------------|!0";

char default_swho_body_msg[] = 
   " !C|!c[!H%W[%02li]C!c] !c[!CUSER: !H%W[%-9.9s]N!c] [!CGROUP: !H%W[%-9.9s]G!c]"
   " [!CON-TM: !H%W[%H:%M]T!c] [!CAC-TM: !H%W[%H:%M]t!c] !C|!0\n"
   " !C|     !c[!CACTIVITY: !H%W[%-54.54s]A!c] !C|!0\n"
   " !C|     !c[!CPATH: !H%W[%-37.37s]P!c] [!CSPEED: !H%W[%6.1f]s !hKB/s!c] !C|!0\n"
   " !C|     !c[!CFROM: !H%W[%-44.44s]H!c] [!CPID: !H%W[%6d]p!c] !C|!0\n"
   " !C|------------------------------------------------------------------------|!0\n";

char default_swho_tail_msg[] = 
   " !C|!c[!CTRAFFIC: !H%W[%7.1f]U !hKB/s (UL)   !H%W[%7.1f]D !hKB/s (DL)   "
   "!H%W[%7.1f]S !hKB/s (TOTAL)!c] !C|!0\n"
   " !C`------------------------------------------------------------------------+!0\n";


char salt_a[] =
  "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ./";
 
struct msg_s who_top_msg  = { "who_top",  0, NULL, 0, 0, default_who_top_msg };
struct msg_s who_body_msg = { "who_body", 0, NULL, 0, 0, default_who_body_msg };
struct msg_s who_tail_msg = { "who_tail", 0, NULL, 0, 0, default_who_tail_msg };

struct msg_s swho_top_msg  = { "swho_top",  0, NULL, 0, 0, default_swho_top_msg };
struct msg_s swho_body_msg = { "swho_body", 0, NULL, 0, 0, default_swho_body_msg };
struct msg_s swho_tail_msg = { "swho_tail", 0, NULL, 0, 0, default_swho_tail_msg };


/* ---- RECENT ADDITIONS ---- */
int                showinfo         = 0;   /* on user change show user info */
int                show_dfl_section = 1;   /* show default section on SITE STATS */
int                sitegive         = 0;

#if (INTSIZE >= 8)
gint64              groupop_rights   = 0x08400F500000000;
gint64              siteop_rights    = 0x7FFFFF7000F0000;
#else
gint64              groupop_rights   = 0x08400B500000000LL;
gint64              siteop_rights    = 0x7FFFFF7000F0000LL;
#endif

int                reply_count      = 0; // number of lines sent

struct dupe_s*     dupe             = NULL;
int                dupe_count       = 0;
int                dupe_size        = 0;
int                dupe_dirty       = 0;

struct ddupe_s*    directory        = NULL;
int                directory_count  = 0;
int                directory_size   = 0;
int                directory_dirty  = 0;
/* ------------------------- */

int                admin_port       = 0;        /* admin port               */
int                admin_port_new   = 0;        /* new admin port           */
char               admin_program[256];
int                admin_socket     = -1;       /* admin socket             */
int                admin_socket_new = -1;       /* new admin socket         */
int                autohome         = 1;        /* create home dir for users */
struct ip_s*       allowip          = NULL;
int                allowip_count    = 0;
char*              alternative_srv  = NULL;
char*              base_dir         = NULL;
char*              bouncer          = NULL;
int                bouncertimeout   = 30;
int                checktimeout     = 0;
struct child_s*    child            = NULL;
int                child_size       = 0;
int                children         = 0;
struct ip_s*       denyip           = NULL;
int                denyip_count     = 0;
char*              destroy_login    = NULL;
char*              destroy_password = NULL;
char*              dupechk          = NULL;
char*              dupe_path        = NULL;
char*              errlog_file      = NULL;
FILE*              errlogf          = NULL;
int                fconv_value      = 0;
fd_set             fdset;
char*              ff_path          = NULL;
int                flags            = FLAGS_DEFAULT;
char*              ftpserrlog_file  = NULL;
struct group_s*    group            = NULL;
int                group_count      = 0;
char*              group_file       = NULL;
int                group_size       = 0;
char*              gstat_file       = NULL;
char*              hidden_files     = NULL;
char*              homepath         = NULL;
int                homeumask        = 0xFF0000;
int                ipbans_dirty     = 0;
char*              kickonnuke       = NULL;
int                logc             = 0;
char*              log_file         = NULL;
int                log_level        = 2;
pid_t              log_pid          = 0;
char*              log_program      = NULL;
FILE*              log_program_f    = NULL;
FILE*              logf             = NULL;
int                login_retries    = 10;
int                min_freemb       = 0;
int                num_anon         = 0;
int                num_users        = 0;
char*              passive_ip       = NULL;     /* ip of a nat router       */
char*              other_ip         = NULL;
char*              permission_file  = NULL;
char*              pid_file         = NULL;
int                port             = 21;       /* primary port             */
int                port_new         = 0;        /* new primary port         */
int                port2            = 0;        /* secondary port           */
int                port2_new        = 0;        /* new secondary port       */
char*              pre_download     = NULL;
char*              pre_upload       = NULL;
char*              program_name     = NULL;
char*              readme_file      = NULL;
char*              rejected_ips     = NULL;
char*              rejected_hops    = NULL;     /* for the traceroute check */
struct section_s*  section          = NULL;
int                section_count    = 0;
int                section_size     = 0;
int                section_stat_dirty = 0;
char               server_dir[256];
char               server_program[256];
char*              server_program_ptr  = NULL;
int                set_gid          = -1;       /* gid of ftp? processes    */
int                set_uid          = -1;       /* uid of ftp? processes    */
struct shandler_s* shandler         = NULL;     /* service handlers         */
int                shandler_count   = 0;        /* number of handlers       */
fd_set             shandler_fdset;              /* handler fdset for select */
int                shandler_size    = 0;        /* max. number of handlers  */
int                sig_array[sig_size];
int                sig_read         = 0;
int                sig_write        = 0;
int                ss               = -1;       /* primary socket           */
int                ss_new           = -1;       /* new primary socket       */
int                ss2              = -1;       /* secondary socket         */
int                ss2_new          = -1;       /* new secondary socket     */
time_t             startup_time     = 0;
char*              stat_dir         = NULL;
char*              stat_file        = NULL;
int                stat_month       = 0;
int                stat_week        = 0;
int                stat_day         = 0;
int                stat_year        = 0;
int                state            = 0;
int                timeout_anon     = 60;
int                timeout_root     = 1800; 
int                timeout_user     = 300;
#ifdef TLS
int                tls_force_flag   = 0;
#endif
gint64              total_ul_speed   = 0;       /* speed of ALL upload sessions */
gint64              total_dl_speed   = 0;
int                umask_value      = 077;
struct user_s*     user             = NULL;
int                user_count       = 0;
char*              user_file        = NULL;
int                user_size        = 0;
char*              xdupe_mask       = NULL;

#ifdef DES_ENCRYPTION
  C_Block          user_key;
  void             string_to_key(char*,C_Block*);
#endif

#ifdef DEBUG
  FILE* debugf = NULL;
#endif

/* EOF */
