/*   externs.h
 *
 *   This file is part of FTP4ALL
 *
 *   Copyright (C) 1996-1999 by Crescent
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _ftps_externs_h
#define _ftps_externs_h

#include "defines.h"

extern struct msg_s cdup_msg;
extern struct msg_s chdir_msg;
extern struct msg_s dele_msg;
extern struct msg_s download_msg;
extern struct msg_s goodbye_msg;
extern struct msg_s list_msg;
extern struct msg_s mkdir_msg;
extern struct msg_s nuke_msg;   
extern struct msg_s unnuke_msg; 
extern struct msg_s rmdir_msg;
extern struct msg_s startup_msg;
extern struct msg_s toomany_msg;
extern struct msg_s upload_msg;
extern struct msg_s welcome_msg;

extern struct sockaddr_in  addr;
extern char*               anonpass;
extern int                 anonymous;
extern gint64               bytes_downloaded;
extern gint64               bytes_uploaded;
extern int                 calc_checksum;
extern struct check_s*     check;
extern int                 check_count;
extern int                 check_size;
extern int                 checktimeout;
extern int                 chmodallowed;
extern int                 close_reason;
extern int                 close_server;
extern struct customcmd_s* customcmd;
extern int                 customcmd_count;
extern int                 customcmd_size;
extern struct check_s*     dcheck;
extern int                 dcheck_count;
extern int                 dcheck_size;
extern struct check_s*     delcheck;
extern int                 delcheck_count;
extern int                 delcheck_size;   
extern struct check_s*     dirdcheck;
extern int                 dirdcheck_count;
extern int                 dirdcheck_size;
extern gint32               dl_speed;
extern char*               dshortcut;
extern int                 dshortcut_len;
extern int                 dshortcut_size;
extern char*               dupechk;
extern char*               dupe_path;
extern int                 fconv_mode;
extern char*               ff_path;
extern int                 flags;
extern int                 fullspeed;
extern struct group_s*     group;
extern int                 group_count;
extern int                 group_size;
extern char*               hidden_files;
extern long                ipaddr;
extern char*               kickonnuke;
extern long                last_speed;
extern long                logc;
extern int                 logged_in;
extern int                 login_kick;
extern int                 login_retries;
extern int                 min_freemb;
extern long                passive_ip_s;
extern long                other_ip_s;
extern char*               pre_download;
extern char*               pre_upload;
extern int                 pasvsock;
extern char*               permission_file;
extern char*               readme_file;
extern char*               rejected_hops;
extern long                rest_offset;
extern int                 retries;
extern int                 scriptabort;
extern char                server_dir[];
/* extern char*               shortcut; */
extern int                 sig_array[];
extern int                 sig_read;
extern int                 sig_write;
extern int                 sock;
extern FILE*               sockf;
extern FILE*               sockfr;
extern int                 structure;
extern int                 timeout;
extern int                 touch;
extern int                 type;
extern gint32               ul_speed;
extern long                umask_value;
extern int                 user_locked;
extern long                default_umask;
extern struct user_s*      user;
extern int                 user_count;
extern int                 user_size;
extern struct user_f_s     usr;
extern int                 showinfo;
extern int                 sitegive;

#endif

/* EOF */
