/*   perm.h
 *
 *   This file is part of FTP4ALL
 *
 *   Copyright (C) 1996-1999 by Crescent
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "pathutil.h"
#include "permfile.h"

FILE* file_open(const char*,char*,const char*,int);

void split_dir(char* fp, char** dir, char** name, int testdir);

int permission_ok(const char* dir, gint32 perm);
int permission_part_ok(const char* dir, gint32 p, int uidok);
int directory_hidden(char* dir);
int directory_flag_set(char* dir, int flag);
int directory_flag_set_recursive(const char* dir, int flag);
int file_permission_ok(const char* dir, char* name, gint32 tperm);
int coloruser(void);
int groupop(void);
int invisible(void);
int siteop(void);
int superuser(void);
char* get_groupname(gint32 gid);
gint32 get_gid(char* name);
gint32 get_uid(char* name);
char* get_groupname(gint32 gid);
char* get_username(gint32 uid);

/* EOF */
