#!/usr/bin/perl -w

##############################################################################
#                                                                            #
#  OpenFTPD Infoline script (c) 2000 primemover                              #
#                                                                            #
#  the output of this script is used as infoline after a directory change.   #
# ---------------------------------------------------------------------------#
#                                                                            #
#  This program is free software; you can redistribute it and/or modify      #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
##############################################################################

use strict;
use Cwd;

sub filesize_to_string {
   my $filesize = $_[0];
   my $sizestr = "";
   if ($filesize > 0x100000) {
      if ($filesize > 0x40000000) {
	 $sizestr = sprintf("%.1f!hGB", $filesize / 0x40000000);	 
      }	 
      else {
	 $sizestr = sprintf("%.0f!hMB", $filesize / 0x100000);
      }
   }
   else { 
      $sizestr = sprintf("%.0f!hKB", $filesize / 1024.0); 
   }
   return $sizestr;
}


my ($ratio,$credit,$ul_session,$ul_total,$dl_session,$dl_total,$users,$max_users,$version,$free,$section);
$ratio      = $ARGV[0];
if ($ARGV[1] =~ /\d+/) {
   $credit     = filesize_to_string($ARGV[1]);
}
else {
   $credit = $ARGV[1];
}
$ul_session = filesize_to_string($ARGV[2]);
$ul_total   = filesize_to_string($ARGV[3]);
$dl_session = filesize_to_string($ARGV[4]);
$dl_total   = filesize_to_string($ARGV[5]);
$users      = $ARGV[6];
$max_users  = $ARGV[7];
$version    = $ARGV[8];
$free       = $ARGV[9];
$section    = $ENV{F4A_SECTION};

# get the free diskspace
my $cwd = getcwd();
$free = filesize_to_string($free * 1024);

# change these two lines if you want to modify the output 
# check doc/colors.txt or the website for the color codes
print "!c[!CRATIO !H$ratio!c]-[!CCREDITS !H$credit!c]-[!CUL !H$ul_session !c(!H$ul_total!c)]-[!CDL !H$dl_session !c(!H$dl_total!c)]!0\n";
print "!c[!CSECTION !H$section!c]-[!CFREE !H$free!c]-[!CUSERS !H$users !hof !H$max_users!c]-[!HOpenFTPD $version!c]!0\n";

# -- EOF --
