#!/usr/bin/perl -w

##############################################################################
#                                                                            #
#  ONELINER v1.0 - (c) 2000 primemover                                       #
#                                                                            #
#  tiny message board for OpenFTPD                                           #
# ---------------------------------------------------------------------------#
#                                                                            #
#  This program is free software; you can redistribute it and/or modify      #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
##############################################################################


# maximum length of a message
my $maxlen = 47;

# maximum lines to show
my $lines  = 10;

##############################################################################

use strict; #always
sub timetostring {
      my ($day_of_month, $month, $year) =
      (localtime)[3..5];   
   my $timestring = sprintf("%04d-%02d-%02d",  $year+1900, $month+1,
   $day_of_month);
   return $timestring;
}

if (not exists $ENV{F4A_USER}) {
   exit(0);
}

my $username = $ENV{F4A_USER};
my $onelfile = $ENV{F4A_STD} . "var/log/onel.log";

my $header = $ENV{F4A_STD} . "msg/onel_top";
my $footer = $ENV{F4A_STD} . "msg/onel_tail";

my @oneliner;

if ($#ARGV < 0) {
   if (-s $header and -s $footer) {       
      open HEAD,"$header" or die " Couldn't open $header";
      while (<HEAD>) {print;}
      close HEAD;
      if (-s $onelfile) {
	 if (open (ONELFILE, "< $onelfile")) {
            while (<ONELFILE>) {
               chomp($_);
    	       if ($_) {
		  push(@oneliner, $_); 
        	  if ($#oneliner >= $lines) { 
		     shift(@oneliner); 
		  }   
               }
            }
	    close(ONELFILE);
	 }
	 foreach my $line (@oneliner) {
            my ($timestamp, $username, $message) = split(/\s+/, $line, 3);
            printf " !C| !H%-10.10s  %-9.9s  %-47.47s !C|!0\n", 
	       $timestamp, $username, $message;    
	 }  
      }
      open HEAD,"$footer" or die " Couldn't open $footer";
      while (<HEAD>) {print;}
      close HEAD;
   }
}
else {
   my $line = "@ARGV";
   if (length($line) > $maxlen) {
      print "Line was not added. (Keep it below 47 chars!)\n";
      exit(0);
   }
   if (open(ONELFILE, ">> $onelfile")) {
      printf ONELFILE "%s %s %s\n", timetostring(), 
         $username, $line;   
      close(ONELFILE);
   }
   print "Your words of wisdom have been added.";
}
