#!/usr/bin/perl -w

##############################################################################
#                                                                            #
#  DELDIR ANNOUNCER (c) 2002 fejf                                            #
#                                                                            #
#  This program is free software; you can redistribute it and/or modify      #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
##############################################################################

$standarddir   = $ENV{'F4A_STD'};

# ----------------------------------------------------------------------------
#  short name of your site for announces (ignored if set in registry)
# ----------------------------------------------------------------------------
$sitename      = "XYZ";


# ----------------------------------------------------------------------------
#  pidfile of your eggdrop sitebot (ignored if set in registry)
# ----------------------------------------------------------------------------
$botpidfile    = $standarddir."/../sitebot/pid.Jackie_B";


# ----------------------------------------------------------------------------
# text file for announce.tcl (ignored if set in registry)
# ----------------------------------------------------------------------------
$announcefile  = $standarddir."/../sitebot/announce.txt";


##############################################################################
# end of configuration (don't edit below unless you know what you are doing  #
##############################################################################

use Cwd;
use Time::Local;
use File::Basename;

use FindBin;
use lib "$FindBin::Bin/";
use primetools;


# ----------------------------------------------------------------------------
#   announce_newdir() - what do you think is this doing ? 
# ----------------------------------------------------------------------------
sub announce_deldir {
   my $formatfile = $standarddir."msg/irc/deldir";
   my $formatstring = "";

   open(FORMATFILE, "< $formatfile") or return 0;
   $formatstring = <FORMATFILE>;
   close(FORMATFILE);
   chomp($formatstring);

   (my $minutes, my $hours) = (localtime)[1..2];
   my $time = sprintf("%02d:%02d", $hours, $minutes);

	@rules = (
		[ '$sitename'		, "$sitename"		],
		[ '$section'		, "$section"		],
		[ '$directory'		, "$announcedir"	],
		[ '$username'		, "$username"		],
		[ '$groupname'		, "$groupname"		],
		[ '$parentdir'		, "$parentdir"		],
		[ '$time'		, "$time"		],
		[ '$tagline'		, "$tagline"		]
	);
	announce_line($announcefile, $botpidfile, substitute($formatstring,0,@rules));
}


###############################################################################
# main program                                                                #
###############################################################################

$cwd = getcwd() or die "unable to get current working directory\n";

# read the ftp4all username and groupname from environment variables
if (exists $ENV{'F4A_USER'}) { $username = $ENV{'F4A_USER'} }
else { $username = "unknown" };
if (exists $ENV{'F4A_GROUP'}) { $groupname = $ENV{'F4A_GROUP'} }
else { $groupname = "unknown" };
if (exists $ENV{'F4A_SECTION'}) { $section = $ENV{'F4A_SECTION'} }
else { $section = "default" };
if (exists $ENV{'F4A_INFO'}) { $tagline = $ENV{'F4A_INFO'} }
else { $tagline = "No tagline" };


#read registry and dircfg to global hashes
%registry = read_registry(); 

if (exists $registry{botpidfile}) { 
   $botpidfile = $registry{botpidfile}; 
}
if (exists $registry{announcefile}) { 
   $announcefile = $registry{announcefile}; 
}

$announcedir = basename($ARGV[0]);
$parentdir = basename(dirname($ARGV[0]));;

if (exists $registry{shortsitename}) {
   $sitename = $registry{shortsitename};
}

if (exists $registry{basedir}) {
   $fullpath = $registry{basedir} . $ARGV[0];
}
else {
   print "ERROR: unable to find basedir in the FTP4ALL registry file.\n";
   exit 1;
}

%dircfg = read_dircfg(dirname($fullpath));

if (exists $dircfg{announce_deldir} and $dircfg{announce_deldir} eq "yes") {
   print " Announcing ...\n";
   announce_deldir();
}

print " Directory was successfully removed.\n";
exit 0;

# --- end of file ---
