# $Id: ftps.pl,v 1.14.2.5 2002/10/26 19:10:46 prime Exp $
#
# initial version by hvr
#
die "script must be called by embedded perl in ftps"
  if not defined $FTP::cfg_server_path;

*STDOUT = STDERR; # redirect stdout to stderr
#*STDIN = undef;

package FTP;
# can't remember what this is for... ;^)
$FTP::debug = 1;

# ...
$FTP::cfg_help_path = "$FTP::cfg_server_path" . "help";
$FTP::cfg_etc_path = "$FTP::cfg_server_path" . "etc";
$FTP::cfg_log_path  = "$FTP::cfg_server_path" . "var/log";
$FTP::cfg_msg_path  = "$FTP::cfg_server_path" . "msg";
$FTP::cfg_bin_path  = "$FTP::cfg_server_path" . "bin";
$FTP::cfg_sbin_path = "$FTP::cfg_server_path" . "sbin";
$FTP::cfg_scrips_path = "$FTP::cfg_server_path" . "scripts";
$FTP::cfg_lib_path = "$FTP::cfg_server_path" . "lib";
$FTP::cfg_var_path = "$FTP::cfg_server_path" .  "var";

#
$FTP::var_user = "nobody";
$FTP::var_group = "nogroup";
$FTP::var_privileged = 0;

package main;
#
sub FTP::load_modules {
  print "FTP::load_modules ()\n" if $FTP::debug;
  local *DIR;

  opendir (DIR, $FTP::cfg_lib_path) || die "can't open lib dir";

  my @modules = grep (/\.pm$/, readdir (DIR));

  closedir (DIR);

  foreach my $module (@modules) {
    my $module_base = $module;
    $module_base =~ s/\.pm$//;
    eval "use lib '$FTP::cfg_lib_path'; use $module_base;";

    if ($@) {
      print "loading script $module failed: $@\n";
    } else {
      print "module $module loaded ok\n" if $FTP::debug;
    }
  }
}

sub FTP::load_scripts {
  print "FTP::load_scripts ()\n" if $FTP::debug;
  local *DIR;

  opendir (DIR, $FTP::cfg_scrips_path) || die "can't open scripts dir";

  my @scripts = grep (/\.pl$/, readdir (DIR));

  closedir (DIR);

  foreach my $script (@scripts) {
    my $scriptfull = "$FTP::cfg_scrips_path/$script";

    if (&FTP::load_file ($scriptfull)) {
      print "loading script $scriptfull failed\n";
    } else {
      print "script $script loaded ok\n" if $FTP::debug;
    }
  }
}

# fixme make it cooler
sub swrite {
  my $format = shift;
  $^A = "";
  formline($format,@_);
  return $^A;
}

sub expand_vars {
  my $line = $_[0];
  my $idx;

  while (($idx = index ($line, "%", $idx)) >= 0
	 && $idx+1 < length ($line))
    {
      my $var = substr ($line, $idx+1, 1);

      substr ($line, $idx, 2) = FTP::get_variable ($var);

      $idx++;
    }

  return $line;
}

sub readfile_expand {
  my $fname = $_[0];
  my $lines = "";
  local *FILE;

  open (FILE, "< $fname") || return "**FILE OPEN ERROR**\n";

  while (my $line = <FILE>) {
    if ($line =~ /%/) {
      $line = expand_vars ($line);
    }

    if ($line =~ /^%\#!/)
      {
	my $cmdl = $line;
	$cmdl =~ s/^%\#!//;
	my ($cmd, $arg) = split (/\s+/, $cmdl, 2);

	$cmd =~ s/\./_/g; # temporary workaround...
	if (defined &{$cmd})
	  {
	    $line = &{$cmd}($arg);
	  }
	else
	  {
	    substr ($line, 0, 3) = "!Bsub not found: !0";
	  }
      }
    $lines .= $line;
  }
  close (FILE);

  return $lines;
}

sub readfile {
  my $fname = shift;
  my $lines = "";
  local *FILE;

  open (FILE, "< $fname") || return "**FILE OPEN ERROR**";
  while (my $line = <FILE>) {
    $lines = $lines . $line;
  }
  close (FILE);

  return $lines;
}

sub FTP::retrieve_help {
  my $topic = shift;

  $topic = lc $topic;

  $topic =~ s/\s/\./g;

  my $helpfile = $FTP::cfg_help_path . "/" . $topic;

  if ( $FTP::var_privileged && -f $helpfile . ".privileged") {
    $helpfile = $helpfile . ".privileged";
  } elsif ( ! -f $helpfile ) {
    $helpfile = $helpfile . ".normal";
  }

  if ( -f $helpfile ) {
    return readfile ($helpfile);
  }

  return;
}

sub FTP::cat_help {
  my $help = shift;
  my $code = shift;

  $help = "help" if not $help;

  if (my $helptxt = FTP::retrieve_help ($help))
    {
      FTP::send_reply ($code, $helptxt, 1);
      FTP::send_reply ($code, "<end of help>");
    }
  else
    {
      FTP::send_reply ($code, "!BNo help available or unknown command '$help'!0");
    }

  return;
}

# events
@FTP::known_events = qw(connect login logout list chdir);

%FTP::events = ( );

sub FTP::bind_event {
  my $event_id = lc ($_[0]);

  if ($event_id !~ /^[^\s]+_(pre|post)$/) {
    printf "FTP::bind_event(%s): bad event specification\n", $event_id;
    return 1;
  }

  my $event = $event_id;

  if ($event !~ s/_(pre|post)$// ) {
    print "FTP::bind_event(): ????\n";
    return 1;
  }

  if (! grep (/^$event$/, @FTP::known_events)) {
    print "FTP::bind_event(): trying to bind to unknown event '$event'\n";
    return 1;
  }

  if ( $FTP::events{$event_id} ) {
    print "warning: overriding already registered event '$event' hook\n";
  }

  $FTP::events{$event_id} = $_[1];

  return 0;
}

sub FTP::event {
  my $event_id = lc (shift);
  my $code = shift;

  if ( $FTP::events{$event_id} )
    {
      my ($rc, $msg) = &{$FTP::events{$event_id}} ($code, @_);

      if ($event_id =~ /_pre$/)	{
	FTP::send_reply ($code, $msg);
      } else {
	FTP::send_reply ($code, $msg);
      }

      return $rc;
    }
  else
    {
      FTP::send_reply ($code, "<no output>");
      return -1;
    }
}

# site commands
%FTP::site_cmds = ( );

sub FTP::bind_site_cmd {
  my $cmd = lc ($_[0]);

  if ( $FTP::site_cmds{$cmd} ) {
    print "warning: overbinding already registered SITE '$cmd' binding\n";
  }

  $FTP::site_cmds{$cmd} = $_[1];
}

sub FTP::cmd_site {
  my $cmdline;
  if ($_[0]) {
    $cmdline = $_[0];
  } else {
    $cmdline = "";
  }

  my ($cmd, $args) = split (/\s+/, $cmdline, 2);
  $cmd = lc ($cmd);

  if ( $FTP::site_cmds{$cmd} )
    {
      print "debug: FTP::cmd_site ('$cmdline')\n" if $FTP::debug;
      my @result = &{ $FTP::site_cmds{$cmd} } ($args);
      my $code = 200;
      my $msg = "<no output>";

      if (@result)
	{
	  $code = $result[0];
	  $msg = $result[1];
	}
      else
	{
	  print "warn: FTP::cmd_site ('$cmdline') had no output\n";
	}

      FTP::send_reply ($code, $msg);
      return 0;
    }
  else
    {
      return 1;
    }

  die "not reached";
}


# LIST
sub FTP::cmd_list 
{
	my $opt_all       = 0;
	my $opt_recursive = 0;
	my $opt_long      = 0;
	my $result = "";
	my $ls_helper;

	$ls_helper = sub 
	{
		my @files = FTP::vfs_readdir ($_[0]);
		my @dirs = ();

		if (!@files)
		{
			print "vfs_readdir: " . FTP::vfs_strerror ($FTP::vfs_errno) . "\n";
			$result .= "ls: " . FTP::vfs_strerror ($FTP::vfs_errno) . "\r\n";
			return;
		}

		my $result_tmp = "";
		my $totalsize = 0;

		@files = sort(@files);
		
		foreach my $file (@files)
		{
			next if (!$opt_all && ($file =~ /^\./ ));
			next if not (my @stat = FTP::vfs_stat (($_[0] ? $_[0] . "/" : '') . $file));

			my ($type, $uid, $gid, $mode, $cdpathflag, $crtime, $chtime, $actime,
				$size, $crc32, $dlc) = @stat;

			if ($opt_recursive && $type == 2 && $file ne "." && $file ne ".." ) 
			{
				push @dirs, ($file);
			}

			my $grp = FTP::userdb_groupname_by_gid ($gid);
			$grp = $gid if (!$grp);

			my $usr = FTP::userdb_username_by_uid ($uid);
			$usr = $uid if (!$usr);

			my $timestr = strftime ("%b %e %H:%M", localtime ($chtime));
			$result_tmp .= sprintf ("%-10s %3d %-9s %-9s %8d %12s %s\r\n",
				mode_str_ls ($type, $mode), $dlc, $usr, $grp, $size, $timestr, $file);

			$totalsize += $size;
		}


		$result .= sprintf ("total %d\r\n", $totalsize / 512);
		$result .= $result_tmp;

		foreach my $dir (@dirs) 
		{
			my $_dir = ($_[0] ? $_[0] . "/" : '') . $dir;
			$result .= "\r\n" . $_dir . ":\r\n";
			&$ls_helper ($_dir);
		}
	};

	my $cmdl = shift;
	my @args;

	$args[0] = $cmdl ? $cmdl : '';

	if ($cmdl =~ /^-/) 
	{
		@args = sgetopt ($cmdl,
			'all|a' => \$opt_all,
			'recursive|R' => \$opt_recursive,
			'long|l' => \$opt_long);

		@args = ('') if (!@args);
	}

	foreach my $arg (@args) 
	{
		#$arg =~ s/\/*$//g;
		&$ls_helper ($arg);
	}

	return $result;
}

# STAT 
sub FTP::cmd_stat 
{
	my $opt_all       = 0;
	my $opt_recursive = 0;
	my $opt_long      = 0;
	my $result = "";
	my $ls_helper;

	$ls_helper = sub 
	{
		my @files = FTP::vfs_readdir ($_[0]);
		my @dirs = ();

		if (!@files)
		{
			print "vfs_readdir: " . FTP::vfs_strerror ($FTP::vfs_errno) . "\n";
			$result .= "ls: " . FTP::vfs_strerror ($FTP::vfs_errno) . "\r\n";
			return;
		}

		my $result_tmp = "";
		my $totalsize = 0;

		@files = sort(@files);

		foreach my $file (@files)
		{
			next if (!$opt_all && ($file =~ /^\./ ));
			next if not (my @stat = FTP::vfs_stat (($_[0] ? $_[0] . "/" : '') . $file));

			my ($type, $uid, $gid, $mode, $cdpathflag, $crtime, $chtime, $actime,
				$size, $crc32, $dlc) = @stat;

			if ($opt_recursive && $type == 2 && $file ne "." && $file ne ".." ) 
			{
				push @dirs, ($file);
			}

			my $grp = FTP::userdb_groupname_by_gid ($gid);
			$grp = $gid if (!$grp);

			my $usr = FTP::userdb_username_by_uid ($uid);
			$usr = $uid if (!$usr);

			my $timestr = strftime ("%b %e %H:%M", localtime ($chtime));
			$result_tmp .= sprintf ("%-10s %3d %-9s %-9s %8d %12s %s\r\n",
				mode_str_ls ($type, $mode), $dlc, $usr, $grp, $size, $timestr, $file);

			$totalsize += $size;
		}


		$result .= "status of $_[0]\r\n";
		$result .= sprintf ("total %d\r\n", $totalsize / 512);
		$result .= $result_tmp;

		foreach my $dir (@dirs) 
		{
			my $_dir = ($_[0] ? $_[0] . "/" : '') . $dir;
			$result .= "\r\n" . $_dir . ":\r\n";
			&$ls_helper ($_dir);
		}
 		$result .= "End of Status\r\n";
	};

	my $cmdl = shift;
	my @args;

	$args[0] = $cmdl ? $cmdl : '';

	if ($cmdl =~ /^-/) 
	{
		@args = sgetopt ($cmdl,
			'all|a' => \$opt_all,
			'recursive|R' => \$opt_recursive,
			'long|l' => \$opt_long);

		@args = ('') if (!@args);
	}

	foreach my $arg (@args) 
	{
		#$arg =~ s/\/*$//g;
		&$ls_helper ($arg);
	}

	return $result;
}

# init stuff
use Cwd;
use POSIX qw(strftime);

&FTP::load_modules ();
&FTP::load_scripts ();
# EOF
