# $Id: request.pl,v 1.5.2.24 2002/12/13 10:09:05 fejf Exp $

my $directorylog    = $FTP::cfg_server_path . "/var/log/directory.log";	# add it to dirlog to show up in "site new"...
my $request_file = $FTP::cfg_var_path . "/request";
my $request_rotatedays = 21;

use FindBin;
use lib "$FindBin::Bin/../lib";
use utils;

my $u = pack("c", 31);
my $b = pack("c", 2);

# ----------------------------------------------------------------------------
#   announce_request() - what do you think is this doing ? 
# ----------------------------------------------------------------------------
sub announce_request {
    my $botpidfile = shift;
    my $announcefile = shift;
    my $sitename = shift;
    my $request = shift;
    my $formatfile = "$FTP::cfg_server_path/msg/irc/request";
    my $formatstring = "";
    my @rules;

    open(FORMATFILE, "< $formatfile") or return 0;
    $formatstring = <FORMATFILE>;
    close(FORMATFILE);
    chomp($formatstring);

    (my $minutes, my $hours) = (localtime)[1..2];
    my $time = sprintf("%02d:%02d", $hours, $minutes);

	@rules = (
		[ '$sitename'		, "$sitename"		],
		[ '$directory'		, "$request"		],
		[ '$username'		, "$FTP::var_user"	],
		[ '$groupname'		, "$FTP::var_group"	],
		[ '$time'		, "$time"		]
	);
	announce_line($announcefile, $botpidfile, substitute($formatstring,0,@rules));
}

sub announce_fillreq {
    my $botpidfile = shift;
    my $announcefile = shift;
    my $sitename = shift;
    my $forusername = shift;
    my $forgroupname = shift;
    my $request = shift;
    my $what = shift;
    my $formatfile = "$FTP::cfg_server_path/msg/irc/$what";
    my $formatstring = "";
    my @rules;

    open(FORMATFILE, "< $formatfile") or return 0;
    $formatstring = <FORMATFILE>;
    close(FORMATFILE);
    chomp($formatstring);

    (my $minutes, my $hours) = (localtime)[1..2];
    my $time = sprintf("%02d:%02d", $hours, $minutes);

	@rules = (
		[ '$sitename'		, "$sitename"		],
		[ '$directory'		, "$request"		],
		[ '$username'		, "$FTP::var_user"	],
		[ '$groupname'		, "$FTP::var_group"	],
		[ '$forusername'	, "$forusername"	],
		[ '$forgroupname'	, "$forgroupname"	],
		[ '$time'		, "$time"		]
	);
	announce_line($announcefile, $botpidfile, substitute($formatstring,0,@rules));
}

sub days_in {
  my %mltable = qw(
   	 1	31
	 3	31
	 4	30
	 5	31
	 6	30
	 7	31
	 8	31
	 9	30
	10	31
	11	30
	12	31);
	# Month is 1..12
	my ($year, $month) = @_;
	return $mltable{$month+0} unless $month == 2;
	return 28 unless is_leap($year);
	return 29;
 }

sub is_leap {
	my ($year) = @_;
	return 0 unless $year % 4 == 0;
	return 1 unless $year % 100 == 0;
	return 0 unless $year % 400 == 0;
	return 1;
}




my $_request_dayssince = sub {
    my ($day_of_month, $month, $year) = (localtime)[3..5];
    my ($thenyear,$thenmonth,$thenday) = split("-",$_[0],3);
    my $days = 0;

# TODO -> atm this does only work for $times < 1 month !
    if ($day_of_month >= $thenday) {
	$days=$day_of_month-$thenday;
    }
    else {
	$days = days_in($year+1900,$month+1) + $day_of_month - $thenday;
    }
    return $days;
};


my $header = &open_format("$FTP::cfg_msg_path/req_top");

my $footer = &open_format("$FTP::cfg_msg_path/req_tail");


my $_site_request = sub  {
    my $body = "";
    my $expired = 0;
    my (@requests, @newreqs, @purgedreqs, @unwanted, $line);
    my ($basedir, $section, $cfgfile, $statfile, $requestbasedir, $deny_dirs, $item, $message);
    my (%reg);
    
    local *REQFILE;

    # show existing requests
    my $line = shift;

    if (not $line) {
	if (open (REQFILE, "< $request_file")) {
	    while (<REQFILE>) {
		chomp($_);
		if ($_) {
		    push(@requests, $_);
		}
	    }
	    close(REQFILE);
	}
	
        my $num = 1;
		
	foreach $line (@requests) {
    	    my ($timestamp, $username, $groupname, $dir) = split(/\s+/, $line, 4);
    	    my $numdays = &$_request_dayssince ($timestamp);
	
    	    if ($numdays < $request_rotatedays) {
		push @newreqs, $line;
		$body .= sprintf ($num % 2 ? "!H%2d!G|!H%-9.9s!G|!H%-10.10s!G|!H%-55.55s!0\n" :
	 	                  "!h%2d!G|!h%-9.9s!G|!h%-10.10s!G|!h%-55.55s!0\n",
		                  $num, $username . ' ' x 9, $timestamp, $dir  . ' ' x 55);
	    	$num++;
	    }
	    else {
		push @purgedreqs, $line;
		$expired=1;
	    }
        }
	if($expired==1) {
		open(REQFILE, "> $request_file");
		foreach $line (@newreqs) {
			printf REQFILE "$line\n";
		}
		close(REQFILE);
		open(REQPURGED, ">> $request_file.purged");
		foreach $line (@purgedreqs) {
			printf REQPURGED "$line\n";
		}
		close(REQPRUGED);
	}
	return (200, $header . $body . $footer);
    }
    # add a request
    else {  
	#read registry and dircfg to global hashes
 	%reg = read_registry(); 
	
# check for unwanted directories (set in dircfg)
	if (exists $reg{basedir}) {
		$basedir = $reg{basedir};
	}
        open(SECTIONSCFG, "< $FTP::cfg_etc_path/sections.cfg");
        while (<SECTIONSCFG>) {
		if ($_ =~ /REQUEST/i) {
			($section, $cfgfile, $statfile, $requestbasedir) = split(/\s+/,$_,4);
			chomp($requestbasedir);
		}
	}
        close(SECTIONSCFG);
	$deny_dirs="";
	if($cfgfile) {
		open(SECCFG, "< $FTP::cfg_etc_path/sections/$cfgfile");
		while(<SECCFG>) {
			if ($_ =~ /^deny_dirs\s+(.+)/i and $deny_dirs = $1) {
				last;
			}
		}
		close(SECCFG);
	}

	if ($deny_dirs) {
		@unwanted = split(/\s/, $deny_dirs);
		foreach $item (@unwanted) {
			if ($line =~ /$item/i) {
				$message = " !C| !BWARNING: this request contains unwanted chars/words " . ' ' x 18 . "!C|!0\n" .
					   " !C|!c ==> !Bdirectory was NOT approved!0" . ' ' x 41 . "!C|!0\n";
				return (200, $message);
			}
		}
	}

#    	if ($FTP::var_user ne "fejf") {
#    		return (200, "!B You are not allowed to request!!!0\n");
#    	}
	#get rid of spaces, "'s , /'s and \'s
	$line =~ s/(\s+|\"|\/|\\)/_/g;

	local *REQUESTLOG;
	open(REQUESTLOG,">> $request_file") or die "ERROR: unable to open request file";
	printf REQUESTLOG "%s %-10s %-10s %s\n", current_time_to_string(), $FTP::var_user,
		$FTP::var_group, $line;
	close(REQUESTLOG);
	if (exists $reg{'botpidfile'} and 
	    exists $reg{'announcefile'}) 
	{ 
		announce_request($reg{'botpidfile'}, 
		                 $reg{'announcefile'},
		                 exists $reg{'shortsitename'} ? $reg{'shortsitename'} : "???",
				 $line);

	}
	return (200, " Request successfully made.");
    }		
};

my $_site_fillrequest = sub {
	my $arg = shift;
	my ($section, $cfgfile, $statfile, $requestbasedir, $relpath);
	my ($timestamp, $forusername, $forgroupname, $requestdir);
	my ($perm, $permfile, $sitename, $basedir, $requestnum, $ok, $rnum);

	if (not $arg) {
		return (200, "You have to specify a request name or number !");
	}
	chomp($arg);

	#read registry and dircfg to global hashes
	my %reg = read_registry(); 

	if (exists $reg{basedir}) { 
		$basedir= $reg{basedir}; 
	}
	if (exists $reg{shortsitename}) {
		$sitename = $reg{shortsitename};
	}
	$permfile = ".permissions";
	if (exists $reg{permissionfile}) {
		$permfile = $reg{permissionfile};
	}

	# FIRST, lets make sure there is a request directory defined, 
	# if not, cant fill requests!
	open(SECTIONSCFG, "< $FTP::cfg_etc_path/sections.cfg");
	while (<SECTIONSCFG>) {
		if ($_ =~ /REQUEST/i) {
			($section, $cfgfile, $statfile, $requestbasedir) = split(/\s+/,$_,4); 
			chomp($requestbasedir);
		}
	}
	close(SECTIONSCFG);
	if (!$requestbasedir) {
		return (200, " There is NO REQUEST directory defined in sections.cfg, ",
			"please contact siteop!");
	} 
	if ($arg =~ /^\d+$/) {
		$requestnum = $arg;
	}
	$ok = 0;
	if (-s $request_file) {
		if (open (REQFILE, "< $request_file")) {
			$rnum = 1;
			while (<REQFILE>) {
				if ($arg) {
					($timestamp, $forusername, $forgroupname, $requestdir) = split(/\s+/, $_, 4);
					chomp($requestdir);
					if (($requestnum) and ($rnum == $requestnum)) {
						$arg = $requestdir;
						$ok = 1; 
						last;
					}
					if ($arg =~ /^\Q$requestdir\E$/) {
						$ok = 1;
						last;
					}
				}
				$rnum++;
			}
			close(REQFILE);
		}
	}

#	if ($forusername eq $FTP::var_user) {
#		return (200, "!B You are not allowed to fill your own requests!!!0\n!B Use site delrequest instead!!!0");
#	}

#	if (not -d "$basedir/$requestbasedir") {
#		return (200, " Request directory was not found. Please contact siteop!\n");
#	}

	if ($ok) {
		open(FILE, "< $request_file");
		open(OUTFILE, "> ${request_file}.tmp");
		while (<FILE>) {
			chomp($_);
			if ($_ !~ /^\d{4}-\d{2}-\d{2}\s+\S+\s+\S+\s+\Q$arg\E$/) {
				print OUTFILE "$_\n";
			}
		}
		close(FILE);
		close(OUTFILE);
		rename ("${request_file}.tmp", "$request_file");

		$perm = pack "i2H8i9", 0, 0, "37377F68", 0, 0, 0, 0, 0, 0, 0, 0, 0;
		chomp($arg);
		mkdir("$basedir$requestbasedir/$arg", 0700);
		# Add it to the directory.log so it shows up in `site new`
		if (-e $directorylog) {
			open(DIRLOG, ">> $directorylog") or die "ERROR: unable to open directory logfile.\n";
		}
		else {
			open(DIRLOG, "> $directorylog") or die "ERROR: unable to open directory logfile.\n";
		}
		$relpath = "$requestbasedir/$arg";
		printf DIRLOG "%s %-10s %-10s %-16s %s\n", timetostring(), $FTP::var_user, $FTP::var_group, $section, $relpath;
		close(DIRLOG);

		open(PERMFILE,"> $basedir/$requestbasedir/$arg/$permfile");
		print PERMFILE $perm;
		close(PERMFILE);

		announce_fillreq($reg{'botpidfile'}, 
				 $reg{'announcefile'},
				 exists $reg{'shortsitename'} ? $reg{'shortsitename'} : "???",
				 $forusername,
				 $forgroupname,
				 $arg,
				 "fillrequest");
		return (200, " !hFillrequest ok, upload into !H$requestbasedir/$arg!0\n");
	}
	else {
		return (200,  " !BAn ERROR occured, please contact siteop!0\n");
	}
};

my $_site_delrequest = sub {
	my %reg;
	my $arg = shift;
	my ($ok, $rnum, $basedir, $sitename, $requestnum);
	my ($timestamp, $forusername, $forgroupname, $requestdir, $req_forusername);

	if (not $arg) {
		return (200, "You have to specify a request dir or number!");
	}
	chomp($arg);
	#read registry and dircfg to global hashes
	%reg = read_registry(); 

	if (exists $reg{basedir}) { 
		$basedir = $reg{basedir}; 
	}
	if (exists $reg{shortsitename}) {
		$sitename = $reg{shortsitename};
	}
	if ($arg =~ /^\d+$/) {
		$requestnum = $arg;
	}
	$ok = 0;
	if (-s $request_file) {
		if (open (REQFILE, "< $request_file")) {
			$rnum = 1;
			while (<REQFILE>) {
				if ($arg) {
					($timestamp, $forusername, $forgroupname, $requestdir) = split(/\s+/, $_, 4);
					chomp($requestdir);
					if (($requestnum) and ($rnum == $requestnum)) {
						$arg = $requestdir;
						$req_forusername=$forusername;
						$ok = 1; 
					}
					if ($arg =~ /\Q$requestdir\E/) {
						$req_forusername=$forusername;
						$ok = 1;
					}
				}
				$rnum++;
			}
			close(REQFILE);
		}
	}
	if (($ok) && (($FTP::var_user =~ /$req_forusername/i) || 
	($FTP::var_siteop == 1) || ($FTP::var_superuser == 1))) {
		open(FILE, "< $request_file");
		open(OUTFILE, "> ${request_file}.tmp");
		while (<FILE>) {
			chomp($_);
			if ($_ !~ /\Q$arg\E/) {
				print OUTFILE "$_\n";
			}
		}
		close(FILE);
		close(OUTFILE);
		rename ("${request_file}.tmp", "$request_file");
		announce_fillreq($reg{'botpidfile'}, $reg{'announcefile'}, exists $reg{'shortsitename'} ? $reg{'shortsitename'} : "???", $forusername, $forgroupname, $arg, "delrequest");
		return (200, " !hDelrequest ok!0\n");
	}
	else {
		return (200,  " !BYou are not allowed to delete requests from other users!0\n");
	}
};

sub request {
  &$_site_request (@_);
}

# bind command
FTP::bind_site_cmd ("req", $_site_request);
FTP::bind_site_cmd ("request", $_site_request);
FTP::bind_site_cmd ("fillreq", $_site_fillrequest);
FTP::bind_site_cmd ("fillrequest", $_site_fillrequest);
FTP::bind_site_cmd ("delreq", $_site_delrequest);
FTP::bind_site_cmd ("delrequest", $_site_delrequest);
